Index: trunk/ab5.0/abdev/abdev/ProjectControl.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/ProjectControl.cpp	(revision 619)
+++ trunk/ab5.0/abdev/abdev/ProjectControl.cpp	(revision 620)
@@ -137,5 +137,5 @@
 								lstrcpy(temporary,
 									projectInfo.pobj_DBFileInfo->ppobj_FileInfo[pobj_ClassTreeView->pProcInfo[i].FileNum]->m_path);
-								GetFullPath(temporary,projectInfo.dir);
+								lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 								hChild=OpenFileWithExtension(temporary);
 							}
@@ -194,5 +194,5 @@
 						if(projectInfo.res.pIconResInfo[i].hTreeItem==hTreeItem){
 							lstrcpy(temporary,projectInfo.res.pIconResInfo[i].path);
-							GetFullPath(temporary,projectInfo.dir);
+							lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 							NewIconEditWindow(temporary);
 							break;
@@ -649,5 +649,5 @@
 	char temporary[MAX_PATH],temp2[MAX_PATH];
 
-	GetRelationalPath(path,projectInfo.dir);
+	lstrcpy( path, projectInfo.GetWorkDir().GetRelationalPath( path ).c_str() );
 
 	//重複チェック
@@ -1273,5 +1273,5 @@
 								temporary[i3]=temp2[i2];
 							}
-							GetFullPath(temporary,projectInfo.dir);
+							lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 							hChild=OpenFileWithExtension(temporary);
 							WndNum=GetWndNum(hChild);
@@ -1355,6 +1355,5 @@
 							for(i3=0;i3<projectInfo.res.NumberOfIconRes;i3++){
 								if(lstrcmpi(projectInfo.res.pIconResInfo[i3].path,temp2)==0){
-									GetFullPath(temp2,projectInfo.dir);
-									NewIconEditWindow(temp2);
+									NewIconEditWindow( projectInfo.GetWorkDir().GetFullPath( temp2 ).c_str() );
 									break;
 								}
@@ -1448,5 +1447,5 @@
 							lstrcpy(temporary,temp2+i3+1);
 							temp2[i3]=0;
-							GetFullPath(temporary,projectInfo.dir);
+							lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 							sscanf(temp2,"%d",&i3);
 
@@ -1477,6 +1476,5 @@
 							for(i3=0;i3<projectInfo.res.NumberOfIconRes;i3++){
 								if(lstrcmpi(projectInfo.res.pIconResInfo[i3].path,temp2)==0){
-									GetFullPath(temp2,projectInfo.dir);
-									NewIconEditWindow(temp2);
+									NewIconEditWindow( projectInfo.GetWorkDir().GetFullPath( temp2 ).c_str() );
 									break;
 								}
@@ -1591,5 +1589,5 @@
 				for(i=0;i<projectInfo.res.NumberOfIconRes;i++){
 					lstrcpy(temporary,projectInfo.res.pIconResInfo[i].path);
-					GetFullPath(temporary,projectInfo.dir);
+					lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 					if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0) sw=1;
 				}
@@ -1678,5 +1676,5 @@
 			for(i=0;i<projectInfo.res.NumberOfIconRes;i++){
 				lstrcpy(temporary,projectInfo.res.pIconResInfo[i].path);
-				GetFullPath(temporary,projectInfo.dir);
+				lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 				if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0){
 					sprintf(buffer+i2,"icon,%s\r\n",projectInfo.res.pIconResInfo[i].path);
@@ -1730,5 +1728,5 @@
 
 	//保存
-	sprintf(temporary,"%s%s.wrk",projectInfo.dir,projectInfo.GetName().c_str());
+	sprintf(temporary,"%s%s.wrk",projectInfo.GetWorkDir().GetPath().c_str(),projectInfo.GetName().c_str());
 	WriteBuffer(temporary,buffer,i2);
 }
@@ -1763,5 +1761,5 @@
 				for(i=0;i<projectInfo.res.NumberOfIconRes;i++){
 					lstrcpy(temporary,projectInfo.res.pIconResInfo[i].path);
-					GetFullPath(temporary,projectInfo.dir);
+					lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 					if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0){
 						SaveDocument(hChild,NULL);
@@ -1824,5 +1822,5 @@
 
 	//保存
-	sprintf(temporary,"%s%s.pj",projectInfo.dir,projectInfo.GetName().c_str());
+	sprintf(temporary,"%s%s.pj",projectInfo.GetWorkDir().GetPath().c_str(),projectInfo.GetName().c_str());
 	WriteBuffer(temporary,buffer,i2);
 
@@ -1854,5 +1852,5 @@
 		//保存（resource.ab）
 		lstrcpy(temporary,"resource.ab");
-		GetFullPath(temporary,projectInfo.dir);
+		lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 		WriteBuffer(temporary,buffer,i2);
 
@@ -1886,5 +1884,5 @@
 		//保存
 		lstrcpy(temporary,projectInfo.ResourceFileName);
-		GetFullPath(temporary,projectInfo.dir);
+		lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 		WriteBuffer(temporary,buffer,i2);
 	}
@@ -1972,5 +1970,5 @@
 
 	//保存
-	sprintf(temporary,"%s%s.idx",projectInfo.dir,projectInfo.GetName().c_str());
+	sprintf(temporary,"%s%s.idx",projectInfo.GetWorkDir().GetPath().c_str(),projectInfo.GetName().c_str());
 	WriteBuffer(temporary,buffer,i2);
 
@@ -1981,5 +1979,5 @@
 		//ウィンドウ関連ファイル（*.wnd）を作成、保存
 		if(projectInfo.ModifyOfMaterial){
-			sprintf(temporary,"%s%s.wnd",projectInfo.dir,projectInfo.GetName().c_str());
+			sprintf(temporary,"%s%s.wnd",projectInfo.GetWorkDir().GetPath().c_str(),projectInfo.GetName().c_str());
 			SaveWindowFile( temporary, projectInfo.windowInfos );
 		}
@@ -2035,5 +2033,5 @@
 	if(bDebug) lstrcpy(temporary,projectInfo.lpszOutput_Debug);
 	else lstrcpy(temporary,projectInfo.lpszOutput_Release);
-	GetFullPath(temporary,projectInfo.dir);
+	lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 
 	hFind=FindFirstFile(temporary,&wfd);
@@ -2059,5 +2057,5 @@
 		//CallBack.wbp
 		lstrcpy(temporary,"CallBack.wbp");
-		GetFullPath(temporary,projectInfo.dir);
+		lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 		hFile=CreateFile(temporary,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 		GetFileTime(hFile,NULL,NULL,&SourceTime);
@@ -2069,5 +2067,5 @@
 		//MakeWindow.wbp
 		lstrcpy(temporary,"MakeWindow.wbp");
-		GetFullPath(temporary,projectInfo.dir);
+		lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 		hFile=CreateFile(temporary,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 		GetFileTime(hFile,NULL,NULL,&SourceTime);