Index: trunk/ab5.0/ablib/src/api_system.sbp
===================================================================
--- trunk/ab5.0/ablib/src/api_system.sbp	(revision 599)
+++ trunk/ab5.0/ablib/src/api_system.sbp	(revision 628)
@@ -3,5 +3,4 @@
 #ifdef UNICODE
 Const _FuncName_AddAtom = "AddAtomW"
-Const _FuncName_CompareString = "CompareStringW"
 Const _FuncName_CopyFile = "CopyFileW"
 Const _FuncName_CreateDirectory = "CreateDirectoryW"
@@ -28,5 +27,4 @@
 Const _FuncName_GetComputerName = "GetComputerNameW"
 Const _FuncName_GetCurrentDirectory = "GetCurrentDirectoryW"
-Const _FuncName_GetDateFormat = "GetDateFormatW"
 Const _FuncName_GetDiskFreeSpace = "GetDiskFreeSpaceW"
 Const _FuncName_GetDiskFreeSpaceEx = "GetDiskFreeSpaceExW"
@@ -50,9 +48,7 @@
 Const _FuncName_GetTempFileName = "GetTempFileNameW"
 Const _FuncName_GetTempPath = "GetTempPathW"
-Const _FuncName_GetTimeFormat = "GetTimeFormatW"
 Const _FuncName_GetUserName = "GetUserNameW"
 Const _FuncName_GetVersionEx = "GetVersionExW"
 Const _FuncName_GetWindowsDirectory = "GetWindowsDirectoryW"
-Const _FuncName_LCMapString = "LCMapStringW"
 Const _FuncName_LoadLibrary = "LoadLibraryW"
 Const _FuncName_LoadLibraryEx = "LoadLibraryExW"
@@ -76,5 +72,4 @@
 #else
 Const _FuncName_AddAtom = "AddAtomA"
-Const _FuncName_CompareString = "CompareStringA"
 Const _FuncName_CopyFile = "CopyFileA"
 Const _FuncName_CreateDirectory = "CreateDirectoryA"
@@ -105,5 +100,4 @@
 Const _FuncName_GetComputerName = "GetComputerNameA"
 Const _FuncName_GetCurrentDirectory = "GetCurrentDirectoryA"
-Const _FuncName_GetDateFormat = "GetDateFormatA"
 Const _FuncName_GetDiskFreeSpace = "GetDiskFreeSpaceA"
 Const _FuncName_GetDiskFreeSpaceEx = "GetDiskFreeSpaceExA"
@@ -123,9 +117,7 @@
 Const _FuncName_GetTempFileName = "GetTempFileNameA"
 Const _FuncName_GetTempPath = "GetTempPathA"
-Const _FuncName_GetTimeFormat = "GetTimeFormatA"
 Const _FuncName_GetUserName = "GetUserNameA"
 Const _FuncName_GetVersionEx = "GetVersionExA"
 Const _FuncName_GetWindowsDirectory = "GetWindowsDirectoryA"
-Const _FuncName_LCMapString = "LCMapStringA"
 Const _FuncName_LoadLibrary = "LoadLibraryA"
 Const _FuncName_LoadLibraryEx = "LoadLibraryExA"
@@ -207,7 +199,4 @@
 Const GPTR =                GMEM_FIXED or GMEM_ZEROINIT
 Const GMEM_DISCARDED =      &H4000
-
-' Locale flag
-Const LOCALE_NOUSEROVERRIDE = &H80000000
 
 'Critical Section
@@ -272,20 +261,8 @@
 #endif
 
-
 Declare Function Beep Lib "kernel32" (dwFreq As DWord, dwDuration As DWord) As BOOL
 Declare Function CloseHandle Lib "kernel32" (hObject As HANDLE) As BOOL
 
 Declare Function CompareFileTime Lib "kernel32" (ByRef FileTime1 As FILETIME, ByRef FileTime2 As FILETIME) As Long
-
-Const NORM_IGNORECASE =     &H00000001
-Const NORM_IGNORENONSPACE = &H00000002
-Const NORM_IGNORESYMBOLS =  &H00000004
-Const SORT_STRINGSORT =     &H00001000
-Const NORM_IGNOREKANATYPE = &H00010000
-Const NORM_IGNOREWIDTH =    &H00020000
-Const CSTR_LESS_THAN =    1
-Const CSTR_EQUAL =        2
-Const CSTR_GREATER_THAN = 3
-Declare Function CompareString Lib "kernel32" Alias _FuncName_CompareString (Locale As LCID, dwCmpFlags As DWord, pString1 As PCTSTR, cchCount1 As Long, pString2 As PCTSTR, cchCount2 As Long) As Long
 
 Declare Function CopyFile Lib "kernel32" Alias _FuncName_CopyFile (pExistingFileName As PCTSTR, pNewFileName As PCTSTR, bFailIfExists As BOOL) As BOOL
@@ -294,8 +271,8 @@
 Declare Function CreateMutex Lib "kernel32" Alias _FuncName_CreateMutex (lpMutexAttributes As *SECURITY_ATTRIBUTES, bInitialOwner As BOOL, lpName As PCTSTR) As HANDLE
 Declare Function CreatePipe Lib "Kernel32" (
-    ByRef hReadPipe As HANDLE,
-    ByRef hWritePipe As HANDLE,
-    ByVal pPipeAttributes As *SECURITY_ATTRIBUTES,
-    ByVal nSize As DWord) As Long
+	ByRef hReadPipe As HANDLE,
+	ByRef hWritePipe As HANDLE,
+	ByVal pPipeAttributes As *SECURITY_ATTRIBUTES,
+	ByVal nSize As DWord) As Long
 Declare Function CreateSemaphore Lib "kernel32" Alias _FuncName_CreateSemaphore (pSemaphoreAttributes As *SECURITY_ATTRIBUTES, lInitialCount As Long, lMaximumCount As Long, pName As PCTSTR) As HANDLE
 
@@ -517,9 +494,4 @@
 Declare Function GetCurrentThreadId Lib "kernel32" () As DWord
 
-Const DATE_SHORTDATE =        &H00000001
-Const DATE_LONGDATE =         &H00000002
-Const DATE_USE_ALT_CALENDAR = &H00000004
-Declare Function GetDateFormat Lib "kernel32" Alias _FuncName_GetDateFormat (Locale As LCID, dwFlags As DWord, ByRef Date As SYSTEMTIME, pFormat As PCTSTR, pDateStr As PTSTR, cchDate As Long) As Long
-
 Declare Function GetDiskFreeSpace Lib "kernel32" Alias _FuncName_GetDiskFreeSpace (pRootPathName As PCTSTR, lpSectorsPerCluster As *DWord, pBytesPerSector As *DWord, pNumberOfFreeClusters As *DWord, pTotalNumberOfClusters As *DWord) As BOOL
 Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias _FuncName_GetDiskFreeSpaceEx (pDirectoryName As PCTSTR, ByRef lpFreeBytesAvailableToCaller As ULARGE_INTEGER, ByRef TotalNumberOfBytes As ULARGE_INTEGER, ByRef TotalNumberOfFreeBytes As ULARGE_INTEGER) As BOOL
@@ -656,10 +628,4 @@
 Declare Function GetTickCount Lib "kernel32" () As DWord
 
-Const TIME_NOMINUTESORSECONDS  = &H00000001
-Const TIME_NOSECONDS           = &H00000002
-Const TIME_NOTIMEMARKER        = &H00000004
-Const TIME_FORCE24HOURFORMAT   = &H00000008
-Declare Function GetTimeFormat Lib "kernel32" Alias _FuncName_GetTimeFormat (Locale As LCID, dwFlags As DWord, ByRef Time As SYSTEMTIME, lpFormat As PCTSTR, lpTimeStr As PTSTR, cchTime As DWord) As BOOL
-Declare Function GetUserDefaultLCID Lib "kernel32" () As LCID
 Declare Function GetUserName Lib "advapi32" Alias _FuncName_GetUserName (pBuffer As PTSTR, ByRef nSize As DWord) As BOOL
 Declare Function GetVersionEx Lib "kernel32" Alias _FuncName_GetVersionEx (ByRef VersionInformation As OSVERSIONINFO) As BOOL
@@ -696,22 +662,8 @@
 Declare Function IsBadReadPtr Lib "kernel32" (lp As VoidPtr, ucb As ULONG_PTR) As BOOL
 Declare Function IsBadWritePtr Lib "kernel32" (lp As VoidPtr, ucb As ULONG_PTR) As BOOL
-Declare Function IsDBCSLeadByte Lib "kernel32" (TestChar As Byte) As BOOL
 
 #ifdef _WIN64
 Declare Function IsWow64Process Lib "kernel32" (hProcess As HANDLE, ByRef bWow64Process As BOOL) As BOOL
 #endif
-
-Const LCMAP_LOWERCASE           = &H00000100  ' lower case letters
-Const LCMAP_UPPERCASE           = &H00000200  ' upper case letters
-Const LCMAP_SORTKEY             = &H00000400  ' WC sort key (normalize)
-Const LCMAP_BYTEREV             = &H00000800  ' byte reversal
-Const LCMAP_HIRAGANA            = &H00100000  ' map katakana to hiragana
-Const LCMAP_KATAKANA            = &H00200000  ' map hiragana to katakana
-Const LCMAP_HALFWIDTH           = &H00400000  ' map double byte to single byte
-Const LCMAP_FULLWIDTH           = &H00800000  ' map single byte to double byte
-Const LCMAP_LINGUISTIC_CASING   = &H01000000  ' use linguistic rules for casing
-Const LCMAP_SIMPLIFIED_CHINESE  = &H02000000  ' map traditional chinese to simplified chinese
-Const LCMAP_TRADITIONAL_CHINESE = &H04000000  ' map simplified chinese to traditional chinese
-Declare Function LCMapString Lib "kernel32" Alias _FuncName_LCMapString (Locale As LCID, dwMapFlags As DWord, lpSrcStr As LPCTSTR, cchSrc As Long, lpDestStr As LPTSTR, cchDest As Long) As Long
 
 Declare Sub LeaveCriticalSection Lib "kernel32" (ByRef lpCriticalSection As CRITICAL_SECTION)
@@ -755,13 +707,4 @@
 ) As Long
 
-Const CP_ACP        = 0      'default to ANSI code page
-Const CP_OEMCP      = 1      'default to OEM  code page
-Const CP_MACCP      = 2      'default to MAC  code page
-Const CP_THREAD_ACP = 3      'current thread's ANSI code page
-Const CP_SYMBOL     = 42     'SYMBOL translations
-Const CP_UTF7       = 65000  'UTF-7 translation
-Const CP_UTF8       = 65001  'UTF-8 translation
-
-Declare Function MultiByteToWideChar Lib "kernel32" (CodePage As DWord, dwFlags As DWord, pMultiByteStr As PCSTR, cchMultiByte As Long, pWideCharStr As PWSTR, cchWideChar As Long) As Long
 Declare Function OpenEvent Lib "kernel32" Alias _FuncName_OpenEvent (dwDesiredAccess As DWord, bInheritHandle As BOOL, lpName As LPCTSTR) As HANDLE
 Declare Function OpenMutex Lib "kernel32" Alias _FuncName_OpenMutex (dwDesiredAccess As DWord, bInheritHandle As BOOL, lpName As LPCTSTR) As HANDLE
@@ -831,4 +774,6 @@
 Declare Function TerminateProcess Lib "kernel32" (hProcess As HANDLE, dwExitCode As DWord) As BOOL
 Declare Function TerminateThread Lib "kernel32" (hThread As HANDLE, dwExitCode As DWord) As BOOL
+
+Const TLS_OUT_OF_INDEXES = &hffffffff As DWord
 Declare Function TlsAlloc Lib "kernel32" () As DWord
 Declare Function TlsFree Lib "kernel32" (dwTlsIndex As DWord) As BOOL
@@ -870,20 +815,4 @@
 Declare Function WaitForSingleObjectEx Lib "kernel32" (hHandle As HANDLE, dwMilliseconds As DWord, bAlertable As BOOL) As DWord
 
-Const WC_COMPOSITECHECK    = &H00000200
-Const WC_DISCARDNS         = &H00000010
-Const WC_SEPCHARS          = &H00000020
-Const WC_DEFAULTCHAR       = &H00000040
-Const WC_NO_BEST_FIT_CHARS = &H00000400
-Declare Function WideCharToMultiByte Lib "Kernel32" (
-	CodePage As DWord,
-	dwFlags As DWord,
-	pWideCharStr As PCWSTR,
-	cchWideChar As Long,
-	pMultiByteStr As PSTR,
-	cbMultiByte As Long,
-	pDefaultChar As PCSTR,
-	pUsedDefaultChar As *BOOL
-) As Long
-
 Declare Function WriteFile Lib "kernel32" (hFile As HANDLE, lpBuffer As VoidPtr, nNumberOfBytesToWrite As DWord, lpNumberOfBytesWritten As *DWord, ByRef pOverlapped As OVERLAPPED) As BOOL
 Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (Destination As VoidPtr, dwLength As DWord)